<?php

define('_PAYMENT_PLATFORM','ligdicash'); //la plateforme pour laquelle le plugin est genere

switch (_PAYMENT_PLATFORM){
    case "payplus":
        /*
          Plugin Name: Passerelle de paiement LigdiCash pour WooCommerce
          Plugin URI: https://ligdicash.com/integration-woocommerce-wordpress/
          Description: Acceptez des paiements mobile de manière simple, rapide et sécurisée
          Version: 2.1.0
          Author: Ligdicash SARL
          Author URI: http://ligdicash.com
         */
        break;

    case "ligdicash":
        /*
          Plugin Name: Passerelle de paiement LigdiCash pour WooCommerce
          Plugin URI: https://ligdicash.com/integration-woocommerce-wordpress/
          Description: Acceptez des paiements mobile de manière simple, rapide et sécurisée
          Version: 2.1.0
          Author: Ligdicash SARL
          Author URI: http://ligdicash.com
         */
        break;

    default:
        /*
          Plugin Name: Passerelle de paiement LigdiCash pour WooCommerce
          Plugin URI: https://ligdicash.com/integration-woocommerce-wordpress/
          Description: Acceptez des paiements mobile de manière simple, rapide et sécurisée
          Version: 2.1.0
          Author: Ligdicash SARL
          Author URI: http://ligdicash.com
         */
        break;
}


if (!defined('ABSPATH')) {
    exit;
}

if (!in_array('woocommerce/woocommerce.php', apply_filters('active_plugins', get_option('active_plugins')))) {
    exit;
}

add_action('plugins_loaded', 'woocommerce_payplus_init', 0);



function woocommerce_payplus_init() {
    if (!class_exists('WC_Payment_Gateway'))
        return;

    class WC_PayPlus extends WC_Payment_Gateway {

        public function __construct() {
            $this->payplus_errors = new WP_Error();

            $this->id = 'ligdicash';
            $this->icon = apply_filters('woocommerce_payplus_icon', plugins_url('assets/images/'._PAYMENT_PLATFORM.'.png', __FILE__));
            $this->has_fields = false;

            $this->init_form_fields();
            $this->init_settings();

            $this->title = $this->settings['title'];
            $this->description = $this->settings['description'];


            $this->api_key = $this->settings['api_key'];
            $this->token = $this->settings['token'];

            $this->sandbox = $this->settings['sandbox'];

            switch (_PAYMENT_PLATFORM) {
                case "payplus":
                    $this->medthod_title = 'PayPlus';
                    $rootUrl = "https://app.payplus.africa";
                    $rootTestUrl = "https://apptest.payplus.africa";
                    break;
                case "ligdicash":
                    $this->medthod_title = 'LigdiCash';
                    $rootUrl = "https://app.ligdicash.com";
                    $rootTestUrl = "https://apptest.ligdicash.com";
                    break;
                default:
                    $this->medthod_title = 'LigdiCash';
                    $rootUrl = "https://app.ligdicash.com";
                    $rootTestUrl = "https://apptest.ligdicash.com";
                    break;
            }

            if ($this->settings['sandbox'] == "yes") {
                $this->posturl = $rootTestUrl.'/pay/v01/redirect/checkout-invoice/create';
                $this->geturl = $rootTestUrl.'/pay/v01/redirect/checkout-invoice/confirm/';
            } else {
                $this->posturl = $rootUrl.'/pay/v01/redirect/checkout-invoice/create';
                $this->geturl = $rootUrl.'/pay/v01/redirect/checkout-invoice/confirm/';
            }

            $this->msg['message'] = "";
            $this->msg['class'] = "";


            if (isset($_REQUEST["ligdicash"])) {
                wc_add_notice($_REQUEST["ligdicash"], "error");
            }

            if (isset($_REQUEST["token"]) && $_REQUEST["token"] <> "") {
                $token = trim($_REQUEST["token"]);
                $this->check_payplus_response($token);
            } else {
                $query_str = $_SERVER['QUERY_STRING'];
                $query_str_arr = explode("?", $query_str);
                foreach ($query_str_arr as $value) {
                    $data = explode("=", $value);
                    if (trim($data[0]) == "token") {
                        $token = isset($data[1]) ? trim($data[1]) : "";
                        if ($token <> "") {
                            $this->check_payplus_response($token);
                        }
                        break;
                    }
                }
            }

            if (version_compare(WOOCOMMERCE_VERSION, '2.0.0', '>=')) {
                add_action('woocommerce_update_options_payment_gateways_' . $this->id, array(&$this, 'process_admin_options'));
            } else {
                add_action('woocommerce_update_options_payment_gateways', array(&$this, 'process_admin_options'));
            }
        }


        function init_form_fields() {
            $description = "";
            switch (_PAYMENT_PLATFORM) {
                case "payplus":
                    $description = "LigdiCash";
                    break;
                case "ligdicash":
                    $description = "LigdiCash";
                    break;
                default:
                    $description = "LigdiCash";
                    break;
            }
            $this->form_fields = array(
                'enabled' => array(
                    'title' => __('Activer/Désactiver', 'ligdicash'),
                    'type' => 'checkbox',
                    'label' => __('Activer le module de paiement '.$description.'.', 'ligdicash'),
                    'default' => 'no'),
                'title' => array(
                    'title' => __('Titre:', 'ligdicash'),
                    'type' => 'text',
                    'description' => __('Texte que verra le client lors du paiement de sa commande.', 'ligdicash'),
                    'default' => __('Paiement mobile,VISA,MasterCard,GIM CEDEAO,ETC', 'ligdicash')),
                'description' => array(
                    'title' => __('Description:', 'ligdicash'),
                    'type' => 'textarea',
                    'description' => __('Description que verra le client lors du paiement de sa commande.', 'ligdicash'),
                    'default' => __('Effectuez des paiements mobiles de manière simple, rapide et sécurisée.', 'ligdicash')),
                'api_key' => array(
                    'title' => __('Clé Principale', 'ligdicash'),
                    'type' => 'text',
                    'description' => __('Clé principale générée lors de la création de votre application.')),
                'token' => array(
                    'title' => __('Token', 'ligdicash'),
                    'type' => 'text',
                    'description' => __('Token généré lors de la création de votre application.')),
                'sandbox' => array(
                    'title' => __('Activer le mode test', 'ligdicash'),
                    'type' => 'checkbox',
                    'default' => 'no',
                    'description' => __("Cocher cette case si vous êtes encore à l'etape des paiements tests.", 'ligdicash')),
            );
        }

        public function admin_options() {

            $description = "";
            switch (_PAYMENT_PLATFORM) {
                case "ligdicash":
                    $description = "ligdicash";
                    break;
                case "ligdicash":
                    $description = "LigdiCash";
                    break;
                default:
                    $description = "LigdiCash";
                    break;
            }

            echo '<h3>' . __('Passerelle de paiement '.$description.'', 'ligdicash') . '</h3>';
            echo '<p>' . __(''.$description.' est la passerelle de paiement la plus populaire pour les achats en ligne.') . '</p>';
            echo '<table class="form-table">';
            // Generate the HTML For the settings form.
            $this->generate_settings_html();
            echo '</table>';
            wp_enqueue_script('payplus_admin_option_js', plugin_dir_url(__FILE__) . 'assets/js/settings.js', array('jquery'), '1.0.1');
        }

        function payment_fields() {
            if ($this->description)
                echo wpautop(wptexturize($this->description));
        }

        protected function get_payplus_args($order) {
            global $woocommerce;

            $description = "";
            switch (_PAYMENT_PLATFORM) {
                case "payplus":
                    $description = "ligdicash";
                    break;
                case "ligdicash":
                    $description = "LigdiCash";
                    break;
                default:
                    $description = "LigdiCash";
                    break;
            }

            //$order = new WC_Order($order_id);
            $txnid = $order->get_id() . '_' . date("ymds");

            $redirect_url = $woocommerce->cart->get_checkout_url();

            $productinfo = "Commande: " . $order->get_id();

            $str = "$this->merchant_id|$txnid|$order->get_total()|$productinfo|$order->get_billing_first_name()|$order->get_billing_email()|||||||||||$this->salt";
            $hash = hash('sha512', $str);

            WC()->session->set('payplus_wc_hash_key', $hash);

            $shipping = 0;
            if ( 0 < $woocommerce->cart->get_shipping_total() ) {
                if ( 'excl' === $woocommerce->cart->tax_display_cart ) {
                    $shipping = $woocommerce->cart->shipping_total;
                } else {
                    $shipping = $woocommerce->cart->shipping_total + $woocommerce->cart->shipping_tax_total;
                }
            }

            $items = $woocommerce->cart->get_cart();
            $payplus_items = array();
            foreach ($items as $item) {
                $payplus_items[] = array(
                    "name" => $item["data"]->post->post_title,
                    "quantity" => $item["quantity"],
                    "unit_price" => $item["line_total"] / (($item["quantity"] == 0) ? 1 : $item["quantity"]),
                    "total_price" => $item["line_total"]
                );
            }

            if($shipping > 0){
                $payplus_items[] = array(
                    "name" => "Frais de livraison",
                    "quantity" => 1,
                    "unit_price" => $shipping,
                    "total_price" => $shipping
                );
            }


            $payplus_args = array(
                "invoice" => array(
                    "items" => $payplus_items,
                    "total_amount" => $order->get_total(),
                    "description" => "Paiement de " . $order->get_total() . " FCFA pour article(s) achetés sur " . htmlentities(htmlspecialchars(get_bloginfo("name")))
                ), "store" => array(
                    "name" => htmlentities(htmlspecialchars(get_bloginfo("name"))),
                    "website_url" => get_site_url()
                ), "actions" => array(
                    "cancel_url" => $redirect_url,
                    "return_url" => $redirect_url
                ), "custom_data" => array(
                    "order_id" => $order->get_id(),
                    "trans_id" => $txnid,
                    "hash" => $hash
                )
            );

            $userorder = new WC_Order($order->get_id());
            $userdata = get_user_meta(get_current_user_id());
            if(!is_null($userdata)){
                if(!empty($userdata["first_name"][0])){
                    $payplus_args["custom_data"]["prenom"] = $userdata["first_name"][0];
                }
                if(!empty($userdata["last_name"][0])){
                    $payplus_args["custom_data"]["nom"] = $userdata["last_name"][0];
                }
                if(!empty($userdata["email"][0])){
                    $payplus_args["custom_data"]["email"] = $userdata["email"][0];
                }
            }
            if(!is_null($userorder)){
                if(empty($payplus_args["custom_data"]["prenom"])){
                    $payplus_args["custom_data"]["prenom"] = $userorder->get_billing_first_name();
                }
                if(empty($payplus_args["custom_data"]["nom"])){
                    $payplus_args["custom_data"]["nom"] = $userorder->get_billing_last_name();
                }
                if(empty($payplus_args["custom_data"]["email"])){
                    $payplus_args["custom_data"]["email"] = $userorder->get_billing_email();
                }
            }


            //$phone_no = get_user_meta(get_current_user_id(), 'billing_phone', true);

            // "Shipping" => $woocommerce->cart->get_cart_shipping_total()

            apply_filters('woocommerce_payplus_args', $payplus_args, $order);
            return $payplus_args;
        }

        function post_to_url($url, $data, $order_id) {
            $commande = urlencode(json_encode($data));
            $ch = curl_init();

            $api_key = $this->api_key;
            $token = $this->token;
            $caller = 1;

            $description = "";
            switch (_PAYMENT_PLATFORM) {
                case "payplus":
                    $description = "PayPlus";
                    break;
                case "ligdicash":
                    $description = "LigdiCash";
                    break;
                default:
                    $description = "LigdiCash";
                    break;
            }

            curl_setopt_array($ch, array(
                CURLOPT_URL => $url,
                CURLOPT_NOBODY => false,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_POST => true,
                CURLOPT_POSTFIELDS => array("commande"=>$commande),
                CURLOPT_SSL_VERIFYPEER => false,
                CURLOPT_HTTPHEADER => array(
                    "Apikey: $api_key",
                    "Apicaller: $caller",
                    "Authorization: Bearer $token"
                ),
            ));
            $response = curl_exec($ch);
            $response_decoded = json_decode($response);
            WC()->session->set('payplus_wc_oder_id', $order_id);
            if ($response_decoded->response_code && $response_decoded->response_code == "00") {
                $order = new WC_Order($order_id);
                $order->add_order_note("".$description." Token: " . $response_decoded->token);
                return $response_decoded->response_text;
            } else {
                global $woocommerce;
                $url = $woocommerce->cart->get_checkout_url();
                if (strstr($url, "?")) {
                    return $url . "&payplus=" . $response_decoded->response_text;
                } else {
                    return $url . "?payplus=" . $response_decoded->response_text;
                }
            }
        }

        function process_payment($order_id) {
            $order = new WC_Order($order_id);
            return array(
                'result' => 'success',
                'redirect' => $this->post_to_url($this->posturl, $this->get_payplus_args($order), $order_id)
            );
        }

        function showMessage($content) {
            return '<div class="box ' . $this->msg['class'] . '-box">' . $this->msg['message'] . '</div>' . $content;
        }

        function get_pages($title = false, $indent = true) {
            $wp_pages = get_pages('sort_column=menu_order');
            $page_list = array();
            if ($title)
                $page_list[] = $title;
            foreach ($wp_pages as $page) {
                $prefix = '';
                // show indented child pages?
                if ($indent) {
                    $has_parent = $page->post_parent;
                    while ($has_parent) {
                        $prefix .= ' - ';
                        $next_page = get_page($has_parent);
                        $has_parent = $next_page->post_parent;
                    }
                }
                // add to page list array array
                $page_list[$page->ID] = $prefix . $page->post_title;
            }
            return $page_list;
        }

        function check_payplus_response($mtoken) {
            global $woocommerce;
            if ($mtoken <> "") {
                $wc_order_id = WC()->session->get('payplus_wc_oder_id');
                $hash = WC()->session->get('payplus_wc_hash_key');
                $order = new WC_Order($wc_order_id);
                try {
                    $ch = curl_init();

                    $api_key = $this->api_key;
                    $token = $this->token;
                    $caller = 1;

                    $url = $this->geturl . "?invoiceToken=" . $mtoken;

                    curl_setopt_array($ch, array(
                        CURLOPT_URL => $url,
                        CURLOPT_NOBODY => false,
                        CURLOPT_RETURNTRANSFER => true,
                        CURLOPT_SSL_VERIFYPEER => false,
                        CURLOPT_HTTPHEADER => array(
                            "Apikey: $api_key",
                            "Apicaller: $caller",
                            "Authorization: Bearer $token"
                        ),
                    ));

                    $response = curl_exec($ch);
                    $response_decoded = json_decode($response);
                    $respond_code = $response_decoded->response_code;
                    if ($respond_code == "00") {

                        $description = "";
                        switch (_PAYMENT_PLATFORM) {
                            case "payplus":
                                $description = "PayPlus";
                                break;
                            case "ligdicash":
                                $description = "LigdiCash";
                                break;
                            default:
                                $description = "PayPlus";
                                break;
                        }

                        //payment found
                        $status = $response_decoded->status;
                        $custom_data = $response_decoded->custom_data;
                        $order_id = $custom_data[0]->valueof_customdata;
                        if ($wc_order_id <> $order_id) {

                            $message = "Votre session de transaction a expiré. Votre numéro de commande est: $order_id --- ";
                            $message_type = "notice";
                            $order->add_order_note($message);
                            $redirect_url = $order->get_cancel_order_url();
                        }
                        if ($status == "completed") {
                            //payment was completely processed
                            $total_amount = strip_tags($woocommerce->cart->get_cart_total());
                            $message = "Merci pour votre achat. La transaction a été un succès, le paiement a été reçu. Votre commande est en cours de traitement. Votre numéro de commande est $order_id";
                            $message_type = "success";

                            //https://docs.woocommerce.com/document/payment-gateway-api/
                            //https://rudrastyh.com/woocommerce/payment-gateway-plugin.html
                            //https://stackoverflow.com/questions/22935358/woocommerce-change-order-status-with-php-code

                            //$order->payment_complete($order_id);
                            $order->update_status( 'completed', '', true );
                            $order->add_order_note('Paiement '.$description.' effectué avec succès<br/>ID unique reçu de '.$description.': ' . $mtoken);
                            $order->add_order_note($this->msg['message']);

                            $order->set_status('completed');
                            $order->save();

                            $woocommerce->cart->empty_cart();
                            $redirect_url = $this->get_return_url($order);
                            $customer = trim($order->get_billing_last_name() . " " . $order->get_billing_first_name());
                        } else {
                            //payment is still pending, or user cancelled request
                            $message = "La transaction n'a pu être complétée.";
                            $message_type = "error";
                            $order->add_order_note("La transaction a échoué ou l'utilisateur a eu à faire demande d'annulation de paiement");
                            $redirect_url = $order->get_cancel_order_url();
                        }
                    } else {
                        //payment not found
                        $message = "Merci de nous avoir choisi. Malheureusement, la transaction a été refusée.";
                        $message_type = "error";
                        $redirect_url = $order->get_cancel_order_url();
                    }

                    $notification_message = array(
                        'message' => $message,
                        'message_type' => $message_type
                    );
                    if (version_compare(WOOCOMMERCE_VERSION, "2.2") >= 0) {
                        add_post_meta($wc_order_id, '_payplus_hash', $hash, true);
                    }
                    update_post_meta($wc_order_id, '_payplus_wc_message', $notification_message);

                    WC()->session->__unset('payplus_wc_hash_key');
                    WC()->session->__unset('payplus_wc_order_id');

                    wp_redirect($redirect_url);
                    exit;
                } catch (Exception $e) {
                    $order->add_order_note('Erreur: ' . $e->getMessage());

                    $redirect_url = $order->get_cancel_order_url();
                    wp_redirect($redirect_url);
                    exit;
                }
            }

        }

        static function add_payplus_fcfa_currency($currencies) {
            $currencies['FCFA'] = __('BCEAO XOF', 'woocommerce');
            return $currencies;
        }

        static function add_payplus_fcfa_currency_symbol($currency_symbol, $currency) {
            switch (
            $currency) {
                case 'FCFA': $currency_symbol = 'FCFA';
                    break;
            }
            return $currency_symbol;
        }

        static function woocommerce_add_payplus_gateway($methods) {
            $methods[] = 'WC_PayPlus';
            return $methods;
        }

        // Add settings link on plugin page
        static function woocommerce_add_payplus_settings_link($links) {
            $settings_link = '<a href="admin.php?page=wc-settings&tab=checkout&section=wc_payplus">Paramètres</a>';
            array_unshift($links, $settings_link);
            return $links;
        }

    }

    $plugin = plugin_basename(__FILE__);

    add_filter('woocommerce_currencies', array('WC_PayPlus', 'add_payplus_fcfa_currency'));
    add_filter('woocommerce_currency_symbol', array('WC_PayPlus', 'add_payplus_fcfa_currency_symbol'), 10, 2);

    add_filter("plugin_action_links_$plugin", array('WC_PayPlus', 'woocommerce_add_payplus_settings_link'));
    add_filter('woocommerce_payment_gateways', array('WC_PayPlus', 'woocommerce_add_payplus_gateway'));
}